# Copyright (c) 2003-2006 Amnesiac Software Project.
# See the 'COPYRIGHT' file for more information.
subpackage hooks

## exit hook
on #-exit 000 "*" {
	@ex.signon=stime($time())
	xecho -v -b Signon time  :    $ex.signon
        xecho -v -b Signoff time :    $stime($time())
        xecho -v -b Total uptime :    $tdiff(${time() - F})
        xecho -v -b signoff: $N \($*\)
}

## catch the "user is away" message and only display it once. 
## Thanks to fudd for this idea and inspiration from his script
## Note that this does not affect the output of /whois since the hook
## is pushed / popped //kreca
on ^301 "*"
{
	@:itemno = finditem(away_users $0)
	if (itemno < 0)
	{
		xecho $fparse(format_whois_away $1-)
		@:itemno=numitems(away_users)
		@setitem(away_users $itemno $0)
	} else if (time() - getitem(away_users_ts $itemno) > 260) {
		xecho $fparse(format_whois_away $1-)
	}
	@setitem(away_users_ts $itemno $time())
}

## chanalone hook
^on #-leave 123 "% % *" {
	if ([$0] != servernick() && remw($0 $chanusers($1)) == servernick()) {
		timer 1 xecho -b You are the only user left on $1
	}
}

## notify hook.
^on ^notify_signon * {
	awecho $G $(c1)signon $(cl)by $(c1)$0$(hblk)!$(cl)$sar(g/@/$(hblk)@$(cl)/$1-) at $Z
}

^on ^notify_signoff * {
	awecho $G $(c1)signoff $(cl)by $(c1)$0 at $Z
}

## edit topic stuff from the epic5 source tree.. used for the /topic_input
## by kreca.
alias edit_topic
{
        ^local thetopic
        ^stack push on 333
        ^stack push on 332
        ^stack push on 331
        ^on ^333 * #
        ^on ^332 * {
                bless
                @ thetopic = [$2-]
        }
        ^on ^331 * #
        ^topic
        ^wait
        ^parsekey erase_line
        ^xtype -literal /topic $thetopic
        stack pop on 331
        stack pop on 332
        stack pop on 333
}

## uptime hooks.
on #-msg 22 * {@lrm=[$1-];@lrmn=[$0]}

on #-send_msg 22 * {@lsm=[$1-];@lsmn=[$0]} 

on #-notice 22 * {@lrn=[$1-];@lrnn=[$0]}

on #-send_notice 22 * {@lsn=[$1-];@lsnn=[$0]}

alias uptime {/load $(loadpath)ans/uptime.ans}

## umode hook
on #-connect 50 * {
	if (!_pubnick) {
		@_pubnick=N
	}
}

on -connect * {
	_orb.relag
	^timer 1 ^mode $N +$getumode
	^qsbar $after(. $statbar)
	eval set quit_message $(J)[$info(i)] - $(a.ver) : $randread($(loadpath)quit.reasons)
}
 
## server hooks.
#connect notice.
^on ^server_notice "% % % connect to*" {
	abecho $fparse(format_timestamp_some $($_timess))$2-
} 

^on ^server_notice "% % Processing connection*" {
        abecho $fparse(format_timestamp_some $($_timess))$2-
} 

^on ^server_notice "% % Looking up your hostname*" {
        abecho $fparse(format_timestamp_some $($_timess))$2-
}
 
^on ^server_notice "% % Checking Ident*" {
        abecho $fparse(format_timestamp_some $($_timess))$2-
}
 
^on ^server_notice "% % Found your hostname*" {
	abecho $fparse(format_timestamp_some $($_timess))$2-
}
 
^on ^server_notice "% % Got ident response*" {
	abecho $fparse(format_timestamp_some $($_timess))$2-
} 
  
^on ^server_notice "% % No Ident response*" {
	abecho $fparse(format_timestamp_some $($_timess))$2-
} 

^on ^server_notice "% % Spoofing your*" {
        abecho $fparse(format_timestamp_some $($_timess))$2-
}

^on ^server_notice "% % You are exempt*" {
        abecho $fparse(format_timestamp_some $($_timess))$2-
}

^on ^server_notice "% % Your host is*" {
	abecho $2-
} 

## disable certain servnumerics here.
#/End of MOTD
^on ^376 * #

## disable you've got mail!.
^on ^mail * #

## disable nonesential annoying ctcp's.
^on ^raw_irc "% PRIVMSG % :FINGER*"
^on ^raw_irc "% PRIVMSG % :CLIENTINFO*"
^on ^raw_irc "% PRIVMSG % :SOUND*"
^on ^raw_irc "% PRIVMSG % :ECHO*"
^on ^raw_irc "% PRIVMSG % :MP3*"

# Deal with modes when they're not set
^on ^324 "% % +" {
	xecho -b Mode for channel $1 is not set
}
