# Copyright (c) 2003-2006 Amnesiac Software Project.
# See the 'COPYRIGHT' file for more information.
subpackage away

#awaystat is per default 0. Without this awaystat will be undefined.
@awaystat=0

alias remlog  {
	if (fexist($(savepath)away.log) == -1) {
		xecho $acban log file does not exist.
	}{
		input "remove log? [y|n]: " {
			if ([$0]==[y]) {
				exec rm $(savepath)away.log
					xecho $acban $(savepath)away.log deleted
			}{
				xecho $acban remlog canceled
			}
		}
	}
}

alias readlog {
	more $(savepath)away.log
}

on -idle * if ([$0]!= 0) { 
	if ([$0]== awayt && awaystat != 1 && togaway != [OFF]) {
		away autoaway after $0 mins
		xecho $acban Auto-Away after $0 minutes
	}
}


^on #-msg 332 * {
	if (awaystat && matchitem(awaymsgs $0) < 0) {
		@setitem(awaymsgs $numitems(awaymsgs) $0)
	}
}

on #-connect 1 * if (awaystat) {
	//away $awaymsg
}

alias away {
	@awayl=[on]
	@awaystat=1                       
	@awaytime=()
	@awaymsg=[$0]?[$*]:awayr
	//away away: \($(awaymsg)\) $fparse(format_away)
	@awaytime=time()
}

alias back {
	if ([$A]) {
		@awayl=[off]
		@awaystat=0
		@delarray(awaymsgs)
		@backtime=time()
		if (awaytime > [0]) {
			@timediff=tdiff2(${backtime - awaytime})
			//away
			xecho -v $acban type /readlog to view log. 
		}

	}{
		xecho -v $acban you are not away..
	}
}

#configs
alias config.awaytime {
	if ( [$0] == [-r] )
	{
		return $awayt
	} else if ([$0] == [-s]) {
		if (# >1) {
			@ awayt = [$1]
		}
		xecho -v $acban away time set to "$awayt"
	}
}

alias config.awaymsg {
	if ( [$0] == [-r] )
	{
		return $awayr
	} else if ([$0] == [-s]) {
		if (# >1) {
			@ awayr = [$1]
		}
		xecho -v $acban away reason set to "$awayr"
	}
}

alias config.awaytog {
	if ( [$0] == [-r] )
	{
		return $togaway
	} else if ([$0] == [-s]) {
		config.matchinput on|off togaway '$1' away toggle
	}
}

alias config.awaylogcrap {
	if ( [$0] == [-r] )
	{
		return $crapl
	} else if ([$0] == [-s]) {
		config.matchinput on|off crapl '$1' misc crap logging
	}
}

alias config.awaylogmsg {
	if ( [$0] == [-r] )
	{
		return $msgl
	} else if ([$0] == [-s]) {
		config.matchinput on|off msgl '$1' msg logging
	}
}

alias config.awaylogdcc {
	if ( [$0] == [-r] )
	{
		return $dccl
	} else if ([$0] == [-s]) {
		config.matchinput on|off dccl '$1' dcc logging
	}
}

alias config.awaylognotice {
	if ( [$0] == [-r] )
	{
		return $notl
	} else if ([$0] == [-s]) {
		config.matchinput on|off notl '$1' notice logging
	}
}

alias config.awaylogpub {
	if ( [$0] == [-r] )
	{
		return $plog
	} else if ([$0] == [-s]) {
		config.matchinput on|off plog '$1' public logging
	}
}

alias config.awaypager {
	if ( [$0] == [-r] )
	{
		return $togpager
	} else if ([$0] == [-s]) {
		config.matchinput on|off togpager '$1' pager
	}
}

#aliases for backwards compability
alias awaytime {
	config.awaytime -s $*
}

alias awaymsg {
	config.awaymsg -s $*
}

alias awaytog {
	config.awaytog -s $*
}

alias logcrap {
	config.awaylogcrap -s $*
}            

alias logm {
	config.awaylogmsg -s $*
}            

alias logd {
	config.awaylogdcc -s $*
}            

alias logn {
	config.awaylognotice -s $*
}            

alias logpub {
	config.awaylogpub -s $*
}            


alias pager {
	config.awaypager -s $*
}

## cmd line aliases.
alias mlog logm $*
alias clog logcrap $*
alias nlog logn $*
alias dlog logd $*
alias playback readlog
alias play readlog
alias atime awaytime $*
alias atog awaytog $*
## pager crap here.
 
^on #-ctcp 2 "% % page*" {
        if (togpager != [off]) {
                beep            
        }           
}

## logging hooks
on #-ctcp 2 "*" if (crapl ==[ON] && awaystat && awayl ==[ON]) {
	@fd = open($(savepath)away.log W)
        @write($fd CTCP $strftime(%x at %I:%M:%S %p) $0 \($userhost()\) requested $2 $3- from $1)
	@close($fd)
}
on #-msg 4 "*" if (msgl ==[ON] && awaystat && awayl ==[ON]) {
	@fd = open($(savepath)away.log W)
	@write($fd MSG $strftime(%x at %I:%M:%S %p) $0 \($userhost()\) $1-)
        @close($fd)
}
on #-notice 3 "*" if (notl==[ON]&&awaystat&&awayl==[ON]&&match(*[*#*]* $1-)==[0]) {
	@fd = open($(savepath)away.log W)
	@write($fd NOTICE $strftime(%x at %I:%M:%S %p) $0 \($userhost()\) $1-)
	@close($fd)
}

on #-notice 4 "*[*#*]*" if (crapl==[ON]&&awaystat&&awayl==[ON]) { 
	@fd = open($(savepath)away.log W)
	@write($fd WALL $strftime(%x at %I:%M:%S %p) $0 $1 $2-)
	@close($fd)}

on #-dcc_request 6 "*" if (dccl ==[ON] && awaystat && awayl ==[ON]) {
        @fd = open($(savepath)away.log W)                            
        @write($fd DCC $strftime(%x at %I:%M:%S %p) dcc $1 request from $0 \($userhost()\))
        @close($fd)}

on #-dcc_chat 4 "*" if (dccl ==[ON] && awaystat && awayl ==[ON]) {
	@fd = open($(savepath)away.log W)
	@write($fd DCC_MSG $strftime(%x at %I:%M:%S %p) $0 $1-)
	@close($fd)}

on #-public_other 4 * if (awayl==[ON]&&awaystat&&match(*$N* $2-)&&plog==[ON]) {
	@fd = open($(savepath)away.log W)                              
        @write($fd PUBLIC $strftime(%x at %I:%M:%S %p) <$0:$1> $2-) 
	@close($fd)}

on #-public 5 * if (awayl==[ON]&&awaystat&&match(*$N* $2-)&&plog==[ON]) {
	@fd = open($(savepath)away.log W)                              
        @write($fd PUBLIC $strftime(%x at %I:%M:%S %p) <$0:$1> $2-) 
	@close($fd)}

on #-kick 33 '$N' {
	if (awayl==[ON]&&awaystat&&crapl==[ON]) {
	@fd = open($(savepath)away.log W)                              
        @write($fd KICK $strftime(%x at %I:%M:%S %p) $1 kicked you off $2 for reason $3-) 
	@close($fd)}}
